Hdu 1087 Super Jumping! Jumping! Jumping!【最大上升子序列和】

来源:互联网 发布:上海大承网络 空中网 编辑:程序博客网 时间:2024/05/22 00:39

Super Jumping! Jumping! Jumping!

Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 29656 Accepted Submission(s): 13236


Problem Description
Nowadays, a kind of chess game called “Super Jumping! Jumping! Jumping!” is very popular in HDU. Maybe you are a good boy, and know little about this game, so I introduce it to you now.



The game can be played by two or more than two players. It consists of a chessboard(棋盘)and some chessmen(棋子), and all chessmen are marked by a positive integer or “start” or “end”. The player starts from start-point and must jumps into end-point finally. In the course of jumping, the player will visit the chessmen in the path, but everyone must jumps from one chessman to another absolutely bigger (you can assume start-point is a minimum and end-point is a maximum.). And all players cannot go backwards. One jumping can go from a chessman to next, also can go across many chessmen, and even you can straightly get to end-point from start-point. Of course you get zero point in this situation. A player is a winner if and only if he can get a bigger score according to his jumping solution. Note that your score comes from the sum of value on the chessmen in you jumping path.
Your task is to output the maximum value according to the given chessmen list.

Input
Input contains multiple test cases. Each test case is described in a line as follow:
N value_1 value_2 …value_N
It is guarantied that N is not more than 1000 and all value_i are in the range of 32-int.
A test case starting with 0 terminates the input and this test case is not to be processed.

Output
For each case, print the maximum according to rules, and one line one case.

Sample Input
3 1 3 24 1 2 3 44 3 3 2 10

Sample Output
4103

本来当成最大上升子序列来做的,后来发现不对,按那样的方法根本没法求,没办法,只能找大神的方法来做了..............


dp 最大上升子序列的和

sum[i]<sum[j]+x[j];


动态规划好难啊,这个题大约是理解了,不过只能算是这个题大约是明白了,还需要有机会深入理解理解................


sum 数组的每一个位置来表示当前位置的所有上升的序列的最大和,一次从起点到 i 位置的循环,加上 动态的跟新循环,更新到最优状态,最后得到的就是需要的结果...

理解不够,说的好迷茫.....


#include<stdio.h>int main(){int n;while(scanf("%d",&n),n){int x[1005]={0},sum[1005]={0};for(int i=1;i<=n;++i){scanf("%d",&x[i]);sum[i]=x[i];}long long ans=sum[0];for(int i=1;i<=n;++i){for(int j=1;j<i;++j){if(x[j]<x[i]&&sum[i]<sum[j]+x[i]){sum[i]=sum[j]+x[i];}}if(sum[i]>ans){ans=sum[i];}}printf("%lld\n",ans);}return 0;} 



/*2016年1月19日16:41 */// 重新做了一次,发现自己还是理解的不够 #include<stdio.h>#include<string.h> #include<algorithm>using namespace std;int main(){//freopen("shuju.txt","r",stdin);int n,x[1005],sum[1005];while(scanf("%d",&n),n){for(int i=0;i<n;++i){scanf("%d",&x[i]);sum[i]=x[i];}int ans=sum[0];for(int i=0;i<n;++i){for(int j=0;j<i;++j){if(x[j]<x[i]){sum[i]=max(sum[i],sum[j]+x[i]);}}ans=max(ans,sum[i]);}printf("%d\n",ans);}return 0;} 

//2016年4月8日11:18


又做了一遍,感觉理解的透彻多了,dp的状态转移真的很巧妙,终于独立AC了


0 0
原创粉丝点击